#ifndef LPCFPIO_H_
#define LPCFPIO_H_


/* Fast General Purpose Input/Output (GPIO) */
#define FIODIR		(*((volatile unsigned long *) 0x3FFFC000))
#define FIOMASK		(*((volatile unsigned long *) 0x3FFFC010))
#define FIOPIN		(*((volatile unsigned long *) 0x3FFFC014))
#define FIOSET		(*((volatile unsigned long *) 0x3FFFC018))
#define FIOCLR		(*((volatile unsigned long *) 0x3FFFC01C))

#define FIO0DIR0	(*((volatile unsigned char *) 0x3FFFC000))
#define FIO0DIR1	(*((volatile unsigned char *) 0x3FFFC001))
#define FIO0DIR2	(*((volatile unsigned char *) 0x3FFFC002))
#define FIO0DIR3	(*((volatile unsigned char *) 0x3FFFC003))
#define FIO0DIRL	(*((volatile unsigned short*) 0x3FFFC000))
#define FIO0DIRU	(*((volatile unsigned short*) 0x3FFFC002))

#define FIO0MASK0	(*((volatile unsigned char *) 0x3FFFC010))
#define FIO0MASK1	(*((volatile unsigned char *) 0x3FFFC011))
#define FIO0MASK2	(*((volatile unsigned char *) 0x3FFFC012))
#define FIO0MASK3	(*((volatile unsigned char *) 0x3FFFC013))
#define FIO0MASKL	(*((volatile unsigned short*) 0x3FFFC010))
#define FIO0MASKU	(*((volatile unsigned short*) 0x3FFFC012))

#define FIO0PIN0	(*((volatile unsigned char *) 0x3FFFC014))
#define FIO0PIN1	(*((volatile unsigned char *) 0x3FFFC015))
#define FIO0PIN2	(*((volatile unsigned char *) 0x3FFFC016))
#define FIO0PIN3	(*((volatile unsigned char *) 0x3FFFC017))
#define FIO0PINL	(*((volatile unsigned short*) 0x3FFFC014))
#define FIO0PINU	(*((volatile unsigned short*) 0x3FFFC016))

#define FIO0SET0	(*((volatile unsigned char *) 0x3FFFC018))
#define FIO0SET1	(*((volatile unsigned char *) 0x3FFFC019))
#define FIO0SET2	(*((volatile unsigned char *) 0x3FFFC01A))
#define FIO0SET3	(*((volatile unsigned char *) 0x3FFFC01B))
#define FIO0SETL	(*((volatile unsigned short*) 0x3FFFC018))
#define FIO0SETU	(*((volatile unsigned short*) 0x3FFFC01A))

#define FIO0CLR0	(*((volatile unsigned char *) 0x3FFFC01C))
#define FIO0CLR1	(*((volatile unsigned char *) 0x3FFFC01D))
#define FIO0CLR2	(*((volatile unsigned char *) 0x3FFFC01E))
#define FIO0CLR3	(*((volatile unsigned char *) 0x3FFFC01F))
#define FIO0CLRL	(*((volatile unsigned short*) 0x3FFFC01C))
#define FIO0CLRU	(*((volatile unsigned short*) 0x3FFFC01E))

/* System Control and Status flags register */
#define SCS		(*((volatile unsigned long *) 0xE01FC1A0))

#endif /*LPCFPIO_H_*/
